// Code generated by "requestgen -method GET -type ProtocolsRequest -url /v1/metrics/protocols/:metric -responseType Response"; DO NOT EDIT.

package glassnodeapi

import (
	"context"
	"encoding/json"
	"fmt"
	"net/url"
	"regexp"
)

func (p *ProtocolsRequest) SetAsset(Asset string) *ProtocolsRequest {
	p.Asset = Asset
	return p
}

func (p *ProtocolsRequest) SetSince(Since int64) *ProtocolsRequest {
	p.Since = Since
	return p
}

func (p *ProtocolsRequest) SetUntil(Until int64) *ProtocolsRequest {
	p.Until = Until
	return p
}

func (p *ProtocolsRequest) SetInterval(Interval Interval) *ProtocolsRequest {
	p.Interval = Interval
	return p
}

func (p *ProtocolsRequest) SetFormat(Format Format) *ProtocolsRequest {
	p.Format = Format
	return p
}

func (p *ProtocolsRequest) SetTimestampFormat(TimestampFormat string) *ProtocolsRequest {
	p.TimestampFormat = TimestampFormat
	return p
}

func (p *ProtocolsRequest) SetMetric(Metric string) *ProtocolsRequest {
	p.Metric = Metric
	return p
}

// GetQueryParameters builds and checks the query parameters and returns url.Values
func (p *ProtocolsRequest) GetQueryParameters() (url.Values, error) {
	var params = map[string]interface{}{}
	// check Asset field -> json key a
	Asset := p.Asset

	// TEMPLATE check-required
	if len(Asset) == 0 {
		return nil, fmt.Errorf("a is required, empty string given")
	}
	// END TEMPLATE check-required

	// assign parameter of Asset
	params["a"] = Asset
	// check Since field -> json key s
	Since := p.Since

	// assign parameter of Since
	params["s"] = Since
	// check Until field -> json key u
	Until := p.Until

	// assign parameter of Until
	params["u"] = Until
	// check Interval field -> json key i
	Interval := p.Interval

	// assign parameter of Interval
	params["i"] = Interval
	// check Format field -> json key f
	Format := p.Format

	// assign parameter of Format
	params["f"] = Format
	// check TimestampFormat field -> json key timestamp_format
	TimestampFormat := p.TimestampFormat

	// assign parameter of TimestampFormat
	params["timestamp_format"] = TimestampFormat

	query := url.Values{}
	for k, v := range params {
		query.Add(k, fmt.Sprintf("%v", v))
	}

	return query, nil
}

// GetParameters builds and checks the parameters and return the result in a map object
func (p *ProtocolsRequest) GetParameters() (map[string]interface{}, error) {
	var params = map[string]interface{}{}

	return params, nil
}

// GetParametersQuery converts the parameters from GetParameters into the url.Values format
func (p *ProtocolsRequest) GetParametersQuery() (url.Values, error) {
	query := url.Values{}

	params, err := p.GetParameters()
	if err != nil {
		return query, err
	}

	for k, v := range params {
		query.Add(k, fmt.Sprintf("%v", v))
	}

	return query, nil
}

// GetParametersJSON converts the parameters from GetParameters into the JSON format
func (p *ProtocolsRequest) GetParametersJSON() ([]byte, error) {
	params, err := p.GetParameters()
	if err != nil {
		return nil, err
	}

	return json.Marshal(params)
}

// GetSlugParameters builds and checks the slug parameters and return the result in a map object
func (p *ProtocolsRequest) GetSlugParameters() (map[string]interface{}, error) {
	var params = map[string]interface{}{}
	// check Metric field -> json key metric
	Metric := p.Metric

	// assign parameter of Metric
	params["metric"] = Metric

	return params, nil
}

func (p *ProtocolsRequest) applySlugsToUrl(url string, slugs map[string]string) string {
	for k, v := range slugs {
		needleRE := regexp.MustCompile(":" + k + "\\b")
		url = needleRE.ReplaceAllString(url, v)
	}

	return url
}

func (p *ProtocolsRequest) GetSlugsMap() (map[string]string, error) {
	slugs := map[string]string{}
	params, err := p.GetSlugParameters()
	if err != nil {
		return slugs, nil
	}

	for k, v := range params {
		slugs[k] = fmt.Sprintf("%v", v)
	}

	return slugs, nil
}

func (p *ProtocolsRequest) Do(ctx context.Context) (Response, error) {

	// no body params
	var params interface{}
	query, err := p.GetQueryParameters()
	if err != nil {
		return nil, err
	}

	apiURL := "/v1/metrics/protocols/:metric"
	slugs, err := p.GetSlugsMap()
	if err != nil {
		return nil, err
	}

	apiURL = p.applySlugsToUrl(apiURL, slugs)

	req, err := p.Client.NewAuthenticatedRequest(ctx, "GET", apiURL, query, params)
	if err != nil {
		return nil, err
	}

	response, err := p.Client.SendRequest(req)
	if err != nil {
		return nil, err
	}

	var apiResponse Response
	if err := response.DecodeJSON(&apiResponse); err != nil {
		return nil, err
	}
	return apiResponse, nil
}
